package devilapp.pdftotext;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.DontInheritEvents;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.*;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;

import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.parser.PdfReaderContentParser;
import com.itextpdf.text.pdf.parser.SimpleTextExtractionStrategy;
import com.itextpdf.text.pdf.parser.TextExtractionStrategy;

import com.itextpdf.*;

/*
 The AdMob library allows you to add ads served by AdMob to your application.
 See the AdMob Tutorial:
   http://www.basic4ppc.com/forum/basic4android-getting-started-tutorials/7300-admob-tutorial-add-ads-your-application.html.
 This library requires some additional configuration as described in the tutorial.
 This view must be set to a size of 320dip x 50dip. Otherwise it will not display.
 */
 
@Version(1.0f)
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE",
//  "android.permission.ACCESS_COURSE_LOCATION", "android.permission.ACCESS_FINE_LOCATION",
//  "android.permission.ACCESS_WIFI_STATE"})
@Author("DevilApp")
@ShortName("PdftToText")
@DependsOn(values={"itextpdf-5.5.6"})
@Events(values={"onMessage(Success As String)"})
//@DontInheritEvents
//@ActivityObject

public class pdftotext {
	
  private BA ba;
  private String eventName;
 
  public void Initialize(BA ba, String EventName) 
  {
	 this.ba = ba;
     this.eventName = EventName.toLowerCase(BA.cul);
  }
  
  public void ParsePdf(String filepdf, String filetxt) throws IOException
  {
	  this.ba = ba;
      String pdf = filepdf;
            String txt = filetxt;
			//String EventName = EventName;
            PdfReader reader = new PdfReader(pdf);
            PdfReaderContentParser parser = new PdfReaderContentParser(reader);
            PrintWriter out = new PrintWriter(new FileOutputStream(txt));
            TextExtractionStrategy strategy;
            for (int i = 1; i <= reader.getNumberOfPages(); i++) {
                strategy = parser.processContent(i, new SimpleTextExtractionStrategy());
                out.println(strategy.getResultantText());
            }
            reader.close();
            out.flush();
            out.close();
			String Convertito = "Done";
			ba.raiseEvent(null, eventName + "_onmessage", "Done");
            ba.Log("Message: " + Convertito);
			 if (ba.subExists(eventName + "_onmessage")) {
                    BA.Log("lib:Raising.. "+eventName + "_onmessage()" + Convertito);                               
                  //app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
					// ba.raiseEvent(null, eventName + "_onmessage", "Done");
					ba.raiseEventFromDifferentThread(this, null, 0,eventName + "_onmessage" , false, new Object[] {Convertito});
              }else {
                  BA.Log("lib: NOTFOUND '"+eventName + "_onmessage");
              }

  }
  
 

}
